/**
 * 
 */
package org.processmining.plugins.pnalignanalysis.visualization.projection;

import java.util.ArrayList;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.plugins.utils.ProvidedObjectHelper;

/**
 * Regardless of logs used for visualization, this class store the log used to
 * export the visualized logs
 * 
 * @author aadrians Oct 4, 2012
 * 
 */
public class LogSource {
	private XLog log;

	public LogSource(XLog log) {
		this.log = log;
	}

	public void export(PluginContext context, String input, int[] selectedIndex) {
		XFactory f = XFactoryRegistry.instance().currentDefault();
		XLog newLog = f.createLog((XAttributeMap) log.getAttributes().clone());
		newLog.getClassifiers().addAll(new ArrayList<XEventClassifier>(log.getClassifiers()));
		for (int idx : selectedIndex) {
			newLog.add((XTrace) log.get(idx).clone());
		}

		// push it to the framework
		ProvidedObjectHelper.publish(context, input, newLog, XLog.class, true);
	}

	/**
	 * @return the log
	 */
	public XLog getLog() {
		return log;
	}

	/**
	 * @param log
	 *            the log to set
	 */
	public void setLog(XLog log) {
		this.log = log;
	}

}
