/**
 * 
 */
package org.processmining.plugins.pnalignanalysis.visualization.projection.util;

import javax.swing.SwingConstants;

import org.processmining.models.connections.GraphLayoutConnection;
import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.ViewSpecificAttributeMap;
import org.processmining.models.graphbased.directed.DirectedGraph;
import org.processmining.models.graphbased.directed.DirectedGraphEdge;
import org.processmining.models.graphbased.directed.DirectedGraphNode;
import org.processmining.models.jgraph.ProMGraphModel;
import org.processmining.models.jgraph.ProMJGraph;

import com.jgraph.layout.JGraphFacade;
import com.jgraph.layout.hierarchical.JGraphHierarchicalLayout;

/**
 * @author aadrians Jul 15, 2012
 * 
 */
public class GraphBuilder {
	//	public static GraphLayoutConnection constructPetrinetP(GraphLayoutConnection oldLayoutConn, PetrinetGraph net,
	//			Marking initMarking, PetrinetGraphP newNet, Marking newMarking,
	//			Map<PetrinetNode, PetrinetNode> mapOrig2ViewNode, Map<PetrinetNode, PetrinetNode> mapView2OrigNode) {
	//		assert (mapOrig2ViewNode != null);
	//
	//		// copy entire petrinet and visualize
	//		for (Place p : net.getPlaces()) {
	//			PlaceP newPlace = newNet.addPlace(p.getLabel());
	//			mapOrig2ViewNode.put(p, newPlace);
	//			if (mapView2OrigNode != null) {
	//				mapView2OrigNode.put(newPlace, p);
	//			}
	//		}
	//		Color inviTransColor = new Color(230, 230, 230);
	//		for (Transition t : net.getTransitions()) {
	//			TransitionP newTrans = newNet.addTransition(t.getLabel(),
	//					(Dimension) t.getAttributeMap().get(AttributeMap.SIZE));
	//			newTrans.setInvisible(t.isInvisible());
	//			newTrans.getAttributeMap().put(AttributeMap.SHOWLABEL, false);
	//			mapOrig2ViewNode.put(t, newTrans);
	//			if (mapView2OrigNode != null) {
	//				mapView2OrigNode.put(newTrans, t);
	//			}
	//			if (newTrans.isInvisible()) {
	//				newTrans.getAttributeMap().put(AttributeMap.FILLCOLOR, inviTransColor);
	//				newTrans.getAttributeMap().put(AttributeMap.SHOWLABEL, true);
	//			}
	//		}
	//		for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> edge : net.getEdges()) {
	//			if (edge instanceof ResetArc) {
	//				newNet.addResetArc((PlaceP) mapOrig2ViewNode.get(edge.getSource()),
	//						(TransitionP) mapOrig2ViewNode.get(edge.getTarget()), edge.getLabel());
	//			} else if (edge instanceof InhibitorArc) {
	//				newNet.addInhibitorArc((PlaceP) mapOrig2ViewNode.get(edge.getSource()),
	//						(TransitionP) mapOrig2ViewNode.get(edge.getTarget()), edge.getLabel());
	//			} else if (edge instanceof Arc) {
	//				if (edge.getSource() instanceof Transition) {
	//					newNet.addArc((TransitionP) mapOrig2ViewNode.get(edge.getSource()),
	//							(PlaceP) mapOrig2ViewNode.get(edge.getTarget()),
	//							net.getArc(edge.getSource(), edge.getTarget()).getWeight());
	//				} else {
	//					newNet.addArc((PlaceP) mapOrig2ViewNode.get(edge.getSource()),
	//							(TransitionP) mapOrig2ViewNode.get(edge.getTarget()),
	//							net.getArc(edge.getSource(), edge.getTarget()).getWeight());
	//				}
	//			} else {
	//				assert edge instanceof DirectedGraphEdge<?, ?>;
	//				System.out.println("Skipping edge: " + edge);
	//
	//			}
	//		}
	//
	//		// copy initial marking
	//		for (Place p : initMarking.baseSet()) {
	//			newMarking.add((PlaceP) mapOrig2ViewNode.get(p), initMarking.occurrences(p));
	//		}
	//
	//		// copy layout
	//		GraphLayoutConnection newLayoutConn = null;
	//		if (oldLayoutConn != null) {
	//			newLayoutConn = new GraphLayoutConnection(newNet);
	//			for (Place p : net.getPlaces()) {
	//				newLayoutConn.setPosition(mapOrig2ViewNode.get(p), oldLayoutConn.getPosition(p));
	//			}
	//			for (Transition t : net.getTransitions()) {
	//				newLayoutConn.setPosition(mapOrig2ViewNode.get(t), oldLayoutConn.getPosition(t));
	//			}
	//			for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> edge : net.getEdges()) {
	//				if (edge instanceof Arc || edge instanceof ResetArc || edge instanceof InhibitorArc) {
	//					newLayoutConn.setEdgePoints(
	//							newNet.getArc(mapOrig2ViewNode.get(edge.getSource()),
	//									mapOrig2ViewNode.get(edge.getTarget())), oldLayoutConn.getEdgePoints(edge));
	//				}
	//			}
	//		}
	//		return newLayoutConn;
	//
	//	}

	public static ProMJGraph buildJGraph(
			DirectedGraph<? extends DirectedGraphNode, ? extends DirectedGraphEdge<? extends DirectedGraphNode, ? extends DirectedGraphNode>> net) {
		return buildJGraph(net, null);
	}

	public static ProMJGraph buildJGraph(
			DirectedGraph<? extends DirectedGraphNode, ? extends DirectedGraphEdge<? extends DirectedGraphNode, ? extends DirectedGraphNode>> net,
			GraphLayoutConnection layoutConnection) {

		ViewSpecificAttributeMap map = new ViewSpecificAttributeMap();

		ProMGraphModel model = new ProMGraphModel(net);
		ProMJGraph jGraph = null;

		if (layoutConnection == null || !layoutConnection.isLayedOut()) {
			if (layoutConnection == null) {
				layoutConnection = new GraphLayoutConnection(net);
			}
			jGraph = new ProMJGraph(model, map, layoutConnection);

			JGraphHierarchicalLayout layout = new JGraphHierarchicalLayout();
			layout.setDeterministic(false);
			layout.setCompactLayout(false);
			layout.setFineTuning(true);
			layout.setParallelEdgeSpacing(15);
			layout.setFixRoots(false);

			layout.setOrientation(map.get(net, AttributeMap.PREF_ORIENTATION, SwingConstants.SOUTH));

			JGraphFacade facade = new JGraphFacade(jGraph);

			facade.setOrdered(false);
			facade.setEdgePromotion(true);
			facade.setIgnoresCellsInGroups(false);
			facade.setIgnoresHiddenCells(false);
			facade.setIgnoresUnconnectedCells(false);
			facade.setDirected(true);
			facade.resetControlPoints();

			facade.run(layout, true);

			java.util.Map<?, ?> nested = facade.createNestedMap(true, true);
			jGraph.getGraphLayoutCache().edit(nested);

			jGraph.setUpdateLayout(layout);

		} else {
			jGraph = new ProMJGraph(model, map, layoutConnection);

		}

		return jGraph;
	}
}
